<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//ES" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="es" lang="es">

<head profile="http://gmpg.org/xfn/11">
   <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
   <title>Migración de Drupal a Wordpress</title>
</head>

<body>

<?php

/*
   drupal2wp.php - Script de migración Drupal->WordPress 
   versión 0.1
   Versiones soportadas (que yo sepa):
      Drupal 4.5.x
      WordPress 2.0.4
   13/10/2006
   Carlos García Argos - http://carlos.garciaargos.com - released under the GPLv2 license
*/

// Configuración: acceso a las bases de datos de origen ($dborig_*) y destino ($dbdest_)
$dborig_srv = "localhost";
$dborig_usr = "user_origen";
$dborig_pwd = "pass_origen";
$dborig_db = "drupaldb";

$dbdest_srv = "localhost";
$dbdest_usr = "user_destino";
$dbdest_pwd = "pass_destino";
$dbdest_db = "wordpressdb";

// Conversiones a realizar
$conv_cat = 1;       // Convertir categorías
$conv_posts = 1;     // Convertir posts
$conv_comments = 1;  // Convertir comentarios: debe estar a 1 $conv_posts
$conv_users = 0;     // Convertir usuarios (por hacer)

// ¿Limpiar el contenido de las tablas?
$trunc_cat = 1;
$trunc_posts = 1;
$trunc_comments = 1;
$trunc_users = 0;

// Las dos funciones siguientes puede que no sean necesarias
/* Función parse: genera la cadena de caracteres del url semántico a partir del título del post */
function parse($str) {
   $ret = utf8_decode($str);
   $special = array ('\'', '"', '(', ')', ':', '/', '&', '¿', '?', ',', ';', '.', '¡', '!' );
   $ret = strtolower(str_replace(" ", "-", $str));
   $ret = str_replace("á", "a", $ret);
   $ret = str_replace("é", "e", $ret);
   $ret = str_replace("í", "i", $ret);
   $ret = str_replace("ó", "o", $ret);
   $ret = str_replace("ú", "u", $ret);
   $ret = str_replace("ñ", "n", $ret);
   $ret = str_replace("Á", "a", $ret);
   $ret = str_replace("É", "e", $ret);
   $ret = str_replace("Í", "i", $ret);
   $ret = str_replace("Ó", "o", $ret);
   $ret = str_replace("Ú", "u", $ret);
   $ret = str_replace("Ñ", "n", $ret);
   $ret = str_replace("+", "-", $ret);
   
   $ret = str_replace($special, "", $ret);
   $ret = str_replace("--", "", $ret);
   
   
   return utf8_encode($ret);
}

/* Compatibilidad entre la base de datos origen (latin-1) y destino (utf-8) 

   Convierte las cadenas de texto del título y el cuerpo de los posts y los mensajes
*/
function parsetitle($str) {
   $ret = utf8_decode($str);
   $ret = str_replace("'", "&#039;", $ret);
   $ret = str_replace("á", "&aacute;", $ret);
   $ret = str_replace("é", "&eacute;", $ret);
   $ret = str_replace("í", "&iacute;", $ret);
   $ret = str_replace("ó", "&oacute;", $ret);
   $ret = str_replace("ú", "&uacute;", $ret);
   $ret = str_replace("ñ", "&ntilde;", $ret);
   $ret = str_replace("Á", "&Aacute;", $ret);
   $ret = str_replace("É", "&Eacute;", $ret);
   $ret = str_replace("Í", "&Iacute;", $ret);
   $ret = str_replace("Ó", "&Oacute;", $ret);
   $ret = str_replace("Ú", "&Uacute;", $ret);
   $ret = str_replace("Ñ", "&Ntilde;", $ret);

   
   return utf8_encode($ret);
}

/* Función formdate toma el timestamp (int) y lo transforma en una fecha 
   en formato AAAA-MM-DD HH:mm:ss (A = año, M = mes, D = dia,
   H = hora, m = minuto, s = segundo)
*/
function formdate($timestamp) {
   $ret = date("Y-m-d G:i:s", $timestamp);
   return $ret;
}

/* Función formgmtdate toma el timestamp y lo transforma en una fecha formateada
   en la zona GMT (+7 horas en Dreamhost)
*/
function formgmtdate($timestamp) {
   $ret = date("Y-m-d G:i:s", $timestamp+3600*7);
   return $ret;
}


// Conexión con los servidores de BBDD y selección de las BBDD
$link_orig = mysql_connect($dborig_srv, $dborig_usr, $dborig_pwd);

$orig_select = mysql_select_db($dborig_db, $link_orig);

if ($orig_select) {
	echo "<h3>Base de datos de origen seleccionada</h3>";
}

$link_dest = mysql_connect($dbdest_srv, $dbdest_usr, $dbdest_pwd);

$dest_select = mysql_select_db($dbdest_db, $link_dest);

if ($dest_select) {
	echo "<h3>Base de datos destino seleccionada</h3>";
}


/*
   Conversión de las tablas de categorías (vocabulary y term_data de Drupal, wp_categories de WordPress)
*/

if ($conv_cat == 1) {
   if ($trunc_cat == 1) {
      $sql = "TRUNCATE TABLE wp_categories";
      $result = mysql_query($sql, $link_dest);
      if (!$result) {
         echo "<h2>Error al truncar la tabla de categorías, no tiene permisos suficientes</h2>\n\n";
      }
   }
   
   echo "<h3>Conversión de categorías...</h3> \n\n";
   $sql = "SELECT * FROM `vocabulary`";
   $result = mysql_query($sql, $link_orig);
   while ($line = mysql_fetch_assoc($result)) {
      $dest = "INSERT INTO wp_categories ( `cat_name`, `category_nicename`, `category_description`, `category_parent`, `category_count`) VALUES ( '$line[name]', '".parse($line[name])."', '$line[description]', '0', '0')";
      mysql_query($dest, $link_dest);
   }
   
   
   $sql = "SELECT * FROM `term_data`";
   $result = mysql_query($sql, $link_orig);
   if (!result) {
      die("Se ha producido un error al acceder a los términos de Drupal");
   }
   
   while ($line = mysql_fetch_assoc($result)) {
      $search_orig_parent = "SELECT `name` FROM `vocabulary` WHERE `vid` = '$line[vid]'";
      $result2 = mysql_query($search_orig_parent, $link_orig);
      $line2 = mysql_fetch_assoc($result2);
      $search_dest_parent = "SELECT `cat_ID` FROM `wp_categories` WHERE `cat_name` = '$line2[name]'";
      $result3 = mysql_query($search_dest_parent, $link_dest);
      $line3 = mysql_fetch_assoc($result3);
      $dest = "INSERT INTO wp_categories (`cat_name`, `category_nicename`, `category_description`, `category_parent`, `category_count`) VALUES ( '$line[name]', '".parse($line[name])."', '$line[description]', '$line3[cat_ID]', '0')";
      mysql_query($dest, $link_dest);
      
      if (!result3) {
         die("Se ha producido un error en la consulta de las categorías en WordPress");
      }
      if (!result2) {
         die("Se ha producido un error en la consulta del vocabulario de Drupal");
      }
   }
   
   echo "Terminado.";
}


/*
   Conversión de los envíos al blog. No distingue tipos (story, page en Drupal), todos los guarda
   en el tipo story
*/

if ($conv_posts) {
   echo "<hr size='3' /><h3>Iniciando conversi&oacute;n de posts</h3>";
   
   $node_sql = "SELECT `nid` , `type` , `title` , `uid` , `status` , `created` , `changed` , `comment` , `promote` , `moderate` , `teaser` , `body` , `revisions` , `sticky` , `format` FROM `node` ORDER BY `nid`";
   
   $result_orig = mysql_query($node_sql, $link_orig);
   if (!result_orig) {
      die("Error al acceder a los posts de Drupal");
   }
   
   $total = count($result_orig);
   
   $count = 0;
   
   
   $sql3 = "UPDATE wp_posts SET `comment_count`='0' WHERE `ID`=1";
   if ($trunc_posts == 1) {
      $sql = "TRUNCATE TABLE wp_posts";
      $result = mysql_query($sql, $link_dest);
      if (!$result) {
         echo "<h2>Error al truncar la tabla de posts, no tiene permisos suficientes</h2>\n\n";
      }
   }
   
   $result_update = mysql_query($sql3, $link_dest);
   if (!result_update) {
      die("Error al actualizar la tabla de posts de WordPress");
   }

   $drupal_nid = array();
   $wordpress_clean_url = array();
   
   
   if ($conv_comments) {
      if ($trunc_cat == 1) {
         $sql = "TRUNCATE TABLE wp_comments";
         $result = mysql_query($sql, $link_dest);
         if (!$result) {
            echo "<h2>Error al truncar la tabla, no tiene permisos suficientes</h2>\n\n";
         }
      }
   }
   
   
   if ($conv_comments) {
      echo "<h3>Iniciando conversión de comentarios</h3>\n\n";
   }

   while ($nodos = mysql_fetch_assoc($result_orig)) {
      
      $sql = "SELECT `tid` FROM `term_node` WHERE `nid`=$nodos[nid]";
      $result_cat = mysql_query($sql, $link_orig);
      if (!result_cat) {
         die("Error seleccionar las relaciones entre posts y términos de Drupal");
      }
      
      $categorias = array();
      $cat_n = array();
      while ($cats = mysql_fetch_assoc($result_cat)) {
         $sql2 = "SELECT `name` FROM `term_data` WHERE `tid` = $cats[tid]";
         $result2 = mysql_query($sql2, $link_orig);
         if (!result2) {
            die("Error al seleccionar los datos de los términos de Drupal");
         }
         while ($catname = mysql_fetch_assoc($result2)) {
            $sql3 = "SELECT `cat_ID`, `cat_name` FROM `wp_categories` WHERE `cat_name`='$catname[name]' AND NOT `category_parent`=0";
            $result3 = mysql_query($sql3, $link_dest);
            if (!result3) {
               die("Error al seleccionar las categorías de WordPress");
            }
            $temp = mysql_fetch_assoc($result3);
            $categorias[] = $temp[cat_ID];
            $cat_n[] = $temp[cat_name];
         }
      }
         
      
      $count++;
      if ($conv_comments) {
         $sql_comments = "SELECT * FROM comments WHERE `nid`=$nodos[nid] ORDER BY `nid`";
         $result_comments = mysql_query($sql_comments, $link_orig);
         if (!result_comments) {
            die("Error al seleccionar los comentarios en Drupal");
         }

         while ($comments = mysql_fetch_assoc($result_comments)) {
            $sql2 = "INSERT INTO wp_comments (`comment_post_ID`, `comment_author`, `comment_author_email`, `comment_author_url`, `comment_author_IP`, `comment_date`, `comment_date_gmt`, `comment_content`, `comment_karma`, `comment_approved`, `comment_agent`, `comment_type`, `comment_parent`, `user_id`) VALUES ( $count, '".parse($comments[name])."', '$comments[mail]', '$comments[homepage]', '$comments[hostname]', '".formdate($comments[timestamp])."', '".formgmtdate($comments[timestamp])."', '".parsetitle($comments[comment])."', '0', '1', '', '', '0', '0')";
            if ($conv_posts) {
               if (!mysql_query($sql2, $link_dest)) {
                  die("Error al insertar comentarios. Consulta realizada: <blockquote>$sql2</blockquote>");
               }
               $sql3 = "UPDATE wp_posts SET `comment_count`=`comment_count`+1 WHERE `ID`=$count";
               if (!mysql_query($sql3, $link_dest)) {
                  die("Error al actualizar el contador de comentarios. Consulta: <blockquote>$sql3</blockquote>");
               }
            }
         }
      }
      
      $node_dest = "INSERT INTO wp_posts SET `post_title`='".parsetitle($nodos[title])."' , `post_author`=1, `post_content`='".parsetitle($nodos[body])."', `post_status`='publish', `comment_status`='open', `ping_status`='open', `post_name`='".parse($nodos[title])."' , `post_modified`='".formdate($nodos[changed])."', `post_modified_gmt`='".formgmtdate($nodos[changed])."', `post_date`='".formdate($nodos[created])."', `post_date_gmt`='".formgmtdate($nodos[created])."' ;";
      
      $drupal_nid[] = $nodos[nid];
      $wordpress_clean_url[] = utf8_decode("/".date("Y",$nodos[created])."/".date("m",$nodos[created])."/".date("d",$nodos[created])."/".parse($nodos[title]));
      
      if (!mysql_query($node_dest, $link_dest)) {
       die("Error en post $count. Query: <blockquote>$node_dest</blockquote>");
      }
      for ($k = 0; $k < count($categorias); $k++) {
         $category_dest = "INSERT INTO wp_post2cat SET `post_id`=$count, `category_id`=$categorias[$k]";
         if (!mysql_query($category_dest, $link_dest)) {
            die("Error al insertar categoria. Query: <blockquote>$category_dest</blockquote>");
         }
         $category_update = "UPDATE wp_categories SET `category_count`=`category_count`+1 WHERE `cat_ID`=$categorias[$k]";
         if (!mysql_query($category_update, $link_dest)) {
            die("Error al actualizar tabla de categorias. Query: <blockquote>$category_update</blockquote>");
         }
      }
   
   }
        echo "<p>Comentarios guardados</p>";
      echo "<p>Posts guardados</p>";
      
      // Guardar el redirectpage.php de los posts
      echo "<hr size='3' /><h3>Guardando archivo redirectpage.php en directorio local</h3>\n\n";
      $cadena = "<?php
      
      if (isset(\$_GET['par'])) {
         \$from = \$_GET['par'];
      
         \$page = ceil(\$from/8) + 1;
         
         header(\"Location: http://carlos.garciaargos.com/page/$page\");
      }
      if (isset(\$_GET['post'])) {
         \$urllist = array(";
      
      for ($k = 0; $k < count($drupal_nid); $k++) {
         $cadena .= "'$wordpress_clean_url[$k]'";
         if ($k < count($drupal_nid) - 1) {
            $cadena .= ", ";
         }
      }
      
      $cadena .= ");\n	\$post = \$_GET['post'];\n\n";
      $cadena .= "	\$postnumbers = array(";
      
      for ($k = 0; $k < count($drupal_nid); $k++) {
         $cadena .= "'$drupal_nid[$k]'";
         if ($k < count($drupal_nid) - 1) {
            $cadena .= ", ";
         }
      }
      
      $cadena .= ");\n\n	\$found = -1;\n\n
         for (\$k = 0; (\$k < count(\$postnumbers)) && (\$found == -1); \$k++) {
            if (\$post == \$postnumbers[\$k]) {
               \$found = \$k;
            }
         }
         
         header(\"Location: \$urllist[\$found]\");
      }
      
      ?>";
   
   // Guardar $cadena en el archivo y yastá
   $red_file = fopen("redirectpage.php", "w");
   $err = 0;
   if (!$red_file) {
      echo "<h2>Error: no se puede escribir en el archivo redirectpage.php</h2>";
      $err = 1;
   }
   else {
      $size = fwrite($red_file, $cadena);
      if ($size === FALSE) {
         echo "<h2>Error: hubo un problema al escribir en el archivo redirectpage.php</h2>";
         $err = 1;
      }
   }
   
   if ($err == 1) {
      echo "<p>Seleccione el siguiente texto, desde '&lt;?php' hasta '?&gt;' y guárdelo en un archivo llamado 'redirectpage.php' en el servidor.</p>\n";
      $cadena = str_replace("\n", "<br>", htmlentities($cadena));
      echo "<blockquote>".$cadena."</blockquote>";
   }
   else {
      echo "<p>Archivo redirectpage.php guardado correctamente en el servidor.</p>";
   }
   
   echo "\n\n";
   
}


if (($conv_posts == 1) && ($conv_cat == 1)) {
   echo "<hr size='3' /><h3>Actualizando los contadores de historias de las categor&iacute;as</h3>\n\n";
   
   if ($conv_cat) {  // Actualizar la categoría padre con el número de posts en las categorías hijas (problema: puede haber multiplicidad de posts en una hija)
      $sql = "SELECT *  FROM wp_categories WHERE NOT `category_parent`=0 ORDER BY `category_parent`";
      $result = mysql_query($sql, $link_dest);
      
      $suma = 0;
      $actual = 0;
      while ($cat = mysql_fetch_assoc($result)) {
         if ($actual != $cat[category_parent]) {
            if ($actual != 0) {
               $sql2 = "UPDATE wp_categories SET `category_count`=$suma WHERE `cat_ID`=$actual";
               if (!mysql_query($sql2, $link_dest)) {
                  die("Error al actualizar la categoria padre. Consulta: <blockquote>$sql2</blockquote>");
               }
            }
            $actual = $cat[category_parent];
            $suma = 0;
         }
         $suma += $cat[category_count];
      }
   }
   
   echo "<p>Terminado</p>";
}



/*
   Convertir la tabla de usuarios: pendiente de hacer
*/
/*$sql = "SELECT * FROM `users`";
$result = mysql_query($sql, $link_orig);
while ($line = mysql_fetch_assoc($result)) {
	$dest = "INSERT INTO users (`uid`, `name`, `pass`, `mail`, `mode`, `sort`, `threshold`, `theme`, `signature`, `created`, `changed`, `status`, `timezone`, `language`, `picture`, `init`, `data`) VALUES ($line[uid], '$line[name]', '$line[pass]', '$line[mail]', $line[mode], $line[sort], $line[threshold], '$line[theme]', '$line[signature]', $line[created], $line[changed], $line[status], '$line[timezone]', '$line[language]', '$line[picture]', '$line[init]', '$line[data]')";
	mysql_query($dest, $link_dest);
}


$sql = "SELECT * FROM `users_roles`";
$result = mysql_query($sql, $link_orig);
while ($line = mysql_fetch_assoc($result)) {
	$dest = "INSERT INTO users_roles (`uid`, `rid`) VALUES ($line[uid], $line[rid])";
	mysql_query($dest, $link_dest);
}




*/


?>

</body></html>